#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>

_PROTOTYPE(int main, (int argc, char **argv));
_PROTOTYPE(void convert, (char *name));

void convert(name)
char *name;
{
    int f;
    char olddata[8];
    char newdata[8];

    f = open(name, O_RDWR);
    if (f < 0)
    {
        fprintf(stderr, "Cannot open file %s\n", name);
        return;
    }

    if (read(f,olddata, 8) != 8)
    {
        fprintf(stderr, "%s: Cannot read enough data\n", name);
        close(f);
        return;
    }
    if ((olddata[2] != 3) || (olddata[3] != 1))
    {
        fprintf(stderr, "%s: not an old style executable\n", name);
        close(f);
        return;
    }
    
    newdata[0] = olddata[3];
    newdata[1] = olddata[2];
    newdata[2] = olddata[1];
    newdata[3] = 0xb;	/* fixed to A_M68K */
    newdata[4] = olddata[7];
    newdata[5] = olddata[6];
    newdata[6] = olddata[5];
    newdata[7] = olddata[4];
    
    lseek(f, 0L, 0);
    if (write(f, newdata, 8) != 8)
    {
        fprintf(stderr, "%s: Cannot write modified data!!\n", name);
    }
    
    close(f);
}

int main(argc, argv)
int argc;
char **argv;
{
    if (argc == 1)
    {
        fprintf(stderr, "usage: %s <file list>\n", argv[0]);
        exit(1);
    }
    argc--;
    argv++;
    while (argc)
    {
        convert(*argv);
	argc--;
	argv++;
    }
    return(0);
}

