#include <minix/config.h>
#if (MACHINE == ATARI)
#if !C_RS232_INT_HANDLERS	/* otherwise don't use anything in this file */



#define	AD_SOUND	0xFFFF8800	/* YM-2149 */
#define	AD_MFP		0xFFFFFA00	/* 68901 */


#define YM_IOA	14
#define PA_SRTS	0x08
#define PA_SRTSB	3
#define PA_SDTR	0x10
#define PA_SDTRB	4


#define R_ENA	0x01
#define IO_SDCD	0x02
#define IO_SCTS	0x04
#define T_UE	0x40
#define T_EMPTY	0x80


#define MF_GPIP	1
#define MF_AER	3
#define MF_RSR	43
#define MF_TSR	45
#define MF_UDR	47


#define EVENT_THRESHOLD	64


#define MS_CTS	0x04

#define ODEVREADY	MS_CTS
#define ODEVREADYB	2
#define ODONE	1
#define OQUEUED	0x20
#define ORAW	2
#define ORAWB	1
#define OSWREADY	0x40
#define OSWREADYB	6
#define OWAKEUP	4


#define IBUFEND	8
#define IHIGHWATER	IBUFEND+4
#define IPTR	IHIGHWATER+4
#define OSTATE	IPTR+4
#define OXOFF	OSTATE+1
#define OBUFEND	OXOFF+1
#define OPTR	OBUFEND+4
#define LSTATUS	OPTR+4
#define PAD	LSTATUS+1
#define FRAMING_ERRORS	PAD+1
#define OVERRUN_ERRORS	FRAMING_ERRORS+2
#define PARITY_ERRORS	OVERRUN_ERRORS+2
#define BREAK_INTERRUPTS	PARITY_ERRORS+2


.globl	_siaint

#ifdef __ACK__
.text

.data

#endif


.globl	_rs_lines
.globl	_tty_events
.globl	_tty_wakeup

.text

_siaint:
	link	a6,#-8
	moveml	d7/a5,sp@-
	lea	_rs_lines,a5
	movew	sr,d7
	movew	#0x2700,sr
	tstb	a6@(9)
	bne	IB_1
	bsr	_in_int
IB_5:
	movew	d7,sr
	moveml	sp@+,d7/a5
	unlk	a6
	rts	
IB_1:
	cmpb	#1,a6@(9)
	bne	IB_2
	bsr	_line_int
	bra	IB_5
IB_2:
	cmpb	#2,a6@(9)
	bne	IB_3
	bsr	out_int
	bra	IB_5
IB_3:
	cmpb	#3,a6@(9)
	bne	IB_4
	clrl	d2
	movel	#AD_MFP,a1
	moveb	a1@(MF_TSR),d2
	movew	d2,d1
	andw	#0xff3e,d1
	beq	IB_5
	movew	d2,sp@-
	pea	_tr_err
	jsr	_printk
	addl	#6,sp
	bra	IB_5
IB_4:
	bsr	_modem_int
	bra	IB_5


_in_int:
	moveb	AD_MFP+MF_UDR,d2
	movel	a5@(IPTR),a0
	moveb	d2,a0@
	btst	#ORAWB,a5@(OSTATE)
	bne	IC_4
	cmpb	a5@(OXOFF),d2
	bne	IC_6
	bclr	#OSWREADYB,a5@(OSTATE)
	bra	IC_4
IC_6:
	bset	#OSWREADYB,a5@(OSTATE)
	bne	IC_4

	orb	#OSWREADY,a5@(OSTATE)
	moveb	AD_MFP+MF_TSR,d1
	andb	#T_EMPTY+T_UE,d1
	beq	IC_4
	bsr	out_int
IC_4:
	cmpl	a5@(IBUFEND),a0
	bcc	IC_F
	addw	#1,_tty_events
	addl	#1,a0
	movel	a0,a5@(IPTR)
	cmpl	a5@(IHIGHWATER),a0
	bne	IC_F
	movel	#AD_SOUND,a1
	moveb	#YM_IOA,a1@
	moveb	a1@,d2
	bclr	#PA_SDTRB,d2
	bset	#PA_SRTSB,d2
	moveb	d2,a1@(2)
	clrb	a5@(2)
IC_F:
	rts	


_line_int:
	movel	#AD_MFP,a1
	moveb	a1@(MF_RSR),d2
	moveb	d2,a5@(LSTATUS)
	andb	#R_ENA,a1@(MF_RSR)
	moveb	a1@(MF_UDR),a5@(PAD)
	btst	#4,d2
	beq	ID_3
	addw	#1,a5@(FRAMING_ERRORS)
ID_3:
	btst	#6,d2
	beq	ID_6
	addw	#1,a5@(OVERRUN_ERRORS)
ID_6:
	btst	#5,d2
	beq	ID_9
	addw	#1,a5@(PARITY_ERRORS)
ID_9:
	btst	#3,d2
	beq	ID_C
	addw	#1,a5@(BREAK_INTERRUPTS)
ID_C:
	rts	


_modem_int:
	movel	#AD_MFP,a1
	moveb	a1@(MF_GPIP),d2
	andb	#IO_SCTS+IO_SDCD,d2
	moveb	a1@(MF_AER),d1
	orb	#IO_SCTS+IO_SDCD,d1
	eorb	d1,d2
	moveb	d2,a1@(MF_AER)
#if (NO_HANDSHAKE == 0)
	moveb	a1@(MF_GPIP),d2
	notb	d2
	andb	#MS_CTS,d2
	bne	IE_3
	bclr	#ODEVREADYB,a5@(OSTATE)
	bra	IE_4
IE_3:
#endif
	bset	#ODEVREADYB,a5@(OSTATE)
	bne	IE_4

	orb	#ODEVREADY,a5@(OSTATE)
	moveb	a1@(MF_TSR),d1
	andb	#T_EMPTY+T_UE,d1
	beq	IE_4
	bsr	out_int
IE_4:
	rts	


out_int:
	moveb	a5@(OSTATE),d2
	cmpb	#ODEVREADY+OQUEUED+OSWREADY,d2
	bcs	IF_3
	movel	a5@(OPTR),a1
	moveb	a1@+,AD_MFP+MF_UDR
	movel	a1,a5@(OPTR)
	cmpl	a5@(OBUFEND),a1
	bcs	IF_3
	addw	#EVENT_THRESHOLD,_tty_events
	eorb	#ODONE+OQUEUED,a5@(OSTATE)

	jsr	_tty_wakeup
IF_3:
	rts	

.data
_tr_err:
.ascii	"sia: transmit error: status=%x\r\n\0"
#endif
#endif

