/*
 * This is the C run-time start-off routine.  It's job is to take the
 * arguments as put on the stack by EXEC, and to parse them and set them up the
 * way _main expects them.
 * It also initializes _environ when this variable isn't defined by the
 * programmer.  The detection of whether _environ belong to us is rather
 * simplistic.  We simply check for some magic value, but there is no other
 * way.
 */

	.globl	_environ
	.globl __penvp
	.globl	_main
	.globl	_exit

	.text
start:	
	movel	sp,a0
	movel	a0@+,d0		| long due to lib/exec.c and mm/exec.c
	movel	d0,d1
	addl	#1,d1
	lsll	#2,d1		| pointers are four bytes on 68000
	movel	a0,a1
	addl	d1,a1
	movel	a1,__penvp
	| Test whether address of environ < address of end.
	| This is done for separate I&D systems.
	| There is no separate I&D for the 68000-MINIX versions (yet),
	| the check is included for safety reasons.
	movel	#_environ,d1
	cmpl	#__end,d1
	jbcc	1f
	cmpw	#21331,_environ
	jbne	1f
	movel	a1,_environ	| save _penvp in environ
1:
	movel	a1,sp@-		| push environ
	movel	a0,sp@-		| push argv
#ifndef __SHORT__
	movel	d0,sp@-		| push argc
#else
	movew	d0,sp@-		| push argc
#endif
	jbsr	_main
#ifndef __SHORT__
	addl	#12,sp
	movel	d0,sp@		| push exit status
#else
	addl	#10,sp
	movew	d0,sp@		| push exit status
#endif
	jbsr	_exit
2:	jra	2b		| just in case _exit fails

	.data
__penvp:
	.long	0
